/*
*	mgtrans.e - Translate Magic PC v5.70 exported doc files.
*
*	This source file is the source of a compiled macro that runs under
*	the Epsilon (see note) text editor.
*
*	Incorporating the macro into Epsilon:
*	-------------------------------------
*	
*	Run the Epsilon macro compiler at a dos prompt to compile this file
*	to 'mgtrans.b'.
*		'\epsilon\bin\eel -ic:\eps700\include mgtrans.e'
*
*	Then start epsilon and run the epsilon command 'load-bytes' supplying
*	'mgtrans.b'	(without quotes) to load the macro into the text editor.
*	Run the command 'write-state' so that the next time epsilon is loaded the
*	load-bytes command will not need to be run.
*
*   Note: "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. 
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	
*
*	Using the macro:
*	----------------
*	Use doc_std.ira to export a Magic program as a document output file.
*	Load the export file into the Epsilon text editor. 
*	Translation begins at the cursor, so to translate the whole file,
*	   make sure cursor is at the beginning of file.
*	Run the command translate-magic-doc.
*	View the translated output in the buffer MagicEzRead.
*
*	Created:
*		06/14/96 Ira Gershenhorn 
*	
*	Updated:
*        
*/
#include "eel.h"
int suppress_dings;
char vertBarString[2];
int savepoint, from, to, endpoint, expressionsPoint, exptablePoint, outmark;
char spinString[]="|/-\\|/-\\";

char d[80];
char d2[80];
char operationsString[100];

char searchstring[20];
char outputBufName[40];
int	outputBufNum;
char mainBufName[40];
int mainBufNum;

int isParameter;
int indentLevel;
char indentExp[255];
int done;

#define SPACE 0x20
#define VERTBAR 179
#define HORIZBAR 196

rfrsh()
{
#ifdef DEBUG
	refresh();
#endif	
}
tab_in()
{
	int i;
	
	for( i= 0; i<indentLevel; i++ )
		stuff( "\t" );
	
}
xfer_out(from, to, prev )
{
	to_buffer( outputBufName );
	outmark = point;
	to_buffer( mainBufName );
	raw_xfer(outputBufNum, from, to);	// copy to other buffer
	to_buffer( outputBufName );
	if( prev )
		point--;
	delete_horizontal_space();
	if( prev )
		point++;
	to_buffer( mainBufName );
}

put_output( s, tabbed )
char *s;
{
	to_buffer( outputBufName );
	outmark = point;
	if( tabbed )
		tab_in();
	if( strlen( s))
		stuff( s );
	to_buffer( mainBufName );
}
del_horiz_space_in_output()
{
	to_buffer( outputBufName );
	delete_horizontal_space();
	to_buffer( mainBufName );
}
putEqualSign() //is never tabbed in
{
	to_buffer( outputBufName );
	outmark = point;
	//delete_horizontal_space();
	stuff( "\t= " );
	to_buffer( mainBufName );
}
copyVarNameToOutput()
{
	int spoint;
	
	spoint = point;
	point = exptablePoint; //????looks ahead instead of behind????
	searchstring[0] = '^';
	searchstring[1] = VERTBAR;
	strcpy(&searchstring[2], d );
	if( re_search( 1, searchstring )){ //search for field code
		beginning_of_line();
		point += 4;
		xfer_out(point, point+20, 0);
	}
	point = spoint;
}
expandVARs()
{
	int expBegin;
	
	to_buffer( outputBufName );
	expBegin = outmark;
	point = outmark;
	while( 1 ){
		if( !parse_string( 1, "'..'VAR|'.'VAR", d ))
			break;
		mark = point;
		note( d);
		search( -1, d );
		kill_region();
		stuff( "@" );
		to_buffer( mainBufName );

		d[0]=d[1];
		d[1]=d[2];
		d[2]='\0';
		if( d[1]='\'' )
			d[1]=SPACE;
			 
		copyVarNameToOutput();

		to_buffer( outputBufName );
	}
	goto_end();
	point--;
	mark = expBegin;
	narrow_to_region();
	fill_paragraph();
	widen_buffer();
	goto_end();
	to_buffer( mainBufName );
}
put_expOrInitAtD()
{
	int spoint;
	
	spoint = point;
	point = expressionsPoint;
	rfrsh();
	searchstring[0] = '^';
	searchstring[1] = SPACE;
	strcpy(&searchstring[2], d );
	if( re_search( 1, searchstring )){ //search for expression number
		point++;
		rfrsh();
		from = point;
		done = 0;
		while( !done ){
			iter = 1;
			down_line();
			beginning_of_line();
			to = point;
			point += 3; // move to spot where if blank means a continuation line.
			rfrsh();
			if( curchar() != SPACE )
				done = 1;
		}
		rfrsh();
		//note( "from=%d to=%d", from, to );
		xfer_out(from, to, 1 );
		expandVARs();
	}
	point = spoint;
}
putExpOrInit()
{
	getExpOrInitInD();
	put_expOrInitAtD();
}
// Gets the condition, and if not YES, inserts and increases indent level.
// while saving previous level.
// If a new condition is evaluated to be same as previous the indent level is left
// as is. Otherwise, it is restored to the previous level.
putCondition( block, isSelect )
{
	int savedIndent;
	
	put_output( "", 1 );
	
	end_of_line();
	search( -1, vertBarString );
	search( -1, vertBarString );
	point++;
	parse_string( 1, "...", d );
	if( 0 == strcmp( d, "Yes" )){
		if( block ){
			put_output( "Do\n", 0 );
			strcpy( indentExp, "Yes" );
			indentLevel++;
		}
		else
			indentExp[0] = '\0';
	}
	else {
		if( 0 != strcmp( indentExp, d )){ //don't repeat 'if' if the same as previous
			if( 0 ==strcmp( d, "No " )){
				if( isSelect )
					put_output( "Never do (don't land on fields):\n", 0 );
				else
					put_output( "Never do:\n", 0 );
			}
			else {
				put_output( "If ", 0 );
				put_expOrInitAtD();
			}
			strcpy( indentExp, d );
			indentLevel++;
			if( !block )
				put_output( "", 1 );
		}
		else {
			if( !block ){
				savedIndent = indentLevel;
				indentLevel = 1; // only want one additional tab
				put_output( "", 1 );
				indentLevel = savedIndent;
			}
			indentLevel++;
		}
	}
	rfrsh();
}
getExpOrInitInD()
{
	beginning_of_line();
	point += 51;
	d[0] ='\0';
	parse_string( 1, "...", d );
	//note( d );
}
hasInit()
{
	getExpOrInitInD();
	if( 0 ==strcmp( d, "  0" ))
		return( 0 );
	else
		return( 1 );
}
putName( tab )
{
	beginning_of_line();
	point += isParameter?28:25;
	if( tab )
		put_output( "", 1 );
	xfer_out(point, point+20, 0 );	// copy to other buffer
}
// clearCondition decreases indent level and erases memory of the condition string
clearCondition()
{
	indentLevel--;
	indentExp[0]='\0'; // is this necessary?
}

int getOperationCode()
{
	int n, n2;
	
	d[0]='\0';
	
	beginning_of_line();
	point += 4; // advance to expected bar
	if( curchar() != VERTBAR ){
		beginning_of_line();
		point += 5;
		parse_string(1, "[a-zA-Z:]+", d);
		//note(d);
		if( 0 == strcmp( d, "Parameter:" ))
			return( 88 );

		beginning_of_line();
		point += 1;
		n = parse_string(1, "[a-zA-Z:]+", d);
		point -= n;
		//note(d);
		if( 0 == strcmp( d, "Operations:" ))
			return( 61 );

		beginning_of_line();
		point += 17; // advance to expected bar
		n = parse_string(1, "[a-zA-Z]+", d);
		point++;
		n2 =parse_string(1, "[a-zA-Z:]+", d2);
		point -= n+n2+1;
		//note(d);
		//note(d2);
		if( 0 == strcmp( d, "Task" ) &&
			0 == strcmp( d2, "Name:" ))
			return( 60 );
		
		else
			return( 0 );
	}
	point++;
	savepoint = point;
	if( curchar() == HORIZBAR )
		return( 99 );
	
	point += 19;
	if( curchar() != VERTBAR )
		return( 0 );
	
	point = savepoint;
	
	parse_string(1, "[a-zA-Z0-9_]+", d);

	//note( d );
	if( 0 == strcmp( d, "Select" ))
		return( 1 );
	else if( 0 == strcmp( d, "Verify" ))
		return( 2);
	else if( 0 == strcmp( d, "Output" ))
		return( 10);
	else if( 0 == strcmp( d, "Input" ))
		return( 11);
	else if( 0 == strcmp( d, "Update" ))
		return( 9);
	else if( 0 == strcmp( d, "Call" )){
		point++;
		parse_string(1, "[a-zA-Z0-9_]+", d);
		if( 0 == strcmp( d, "Program" ))
			return( 7);
		else
			return( 71);
	}
	else if( 0 == strcmp( d, "Evaluate" ))
		return( 8);
	else if( 0 == strcmp( d, "Block" ))
		return( 5);
	else if( 0 == strcmp( d, "End" )){
		point++;
		parse_string(1, "[a-zA-Z0-9_]+", d);
		if( 0 == strcmp( d, "Block" ))
			return( 6);
		else
			return( 0 );
	}
	else
		return( 0 );
}
putLine()
{
	beginning_of_line();
	from = point;
	end_of_line();
	raw_xfer(outputBufNum, from, point);	// copy to other buffer
}
doNext()
{
	int opCode, savedIndentLevel;
	
	opCode = getOperationCode();
	switch (opCode) {
	case 99://blank comment line
		//put_output( "\n", 0 );
		break;
			
	case 9:		// update Var:
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		putName(0);
		putEqualSign();
		putExpOrInit();
		indentLevel = savedIndentLevel;
		break;

	case 7: //Call Program:
	case 71:// Call Task:
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		beginning_of_line();
		point+= 10;
		if( curchar() == 'P' )
			put_output( "Prog: ", 0 );
		else
			put_output( "Task: ", 0 );
		putName(0);
		put_output( "\n", 0 );
		indentLevel = savedIndentLevel;
		break;

	case 11:// Input Form
	case 10:// Output Form
	case 13:// Exit on Exp:
	case 2:	// Verify Exp:
		savedIndentLevel = indentLevel;
		putCondition(0,0);

		if( opCode == 11 )
			put_output( "Input Form: ", 0 );
		else if( opCode == 10 )
			put_output( "Output Form: ", 0 );
		else if( opCode == 13 )
			put_output( "Exit to: ", 0 );
		else if( opCode == 2 ){
			beginning_of_line();
			point+=53;
			if(curchar() == 'E' )
				put_output( "Error: ", 0 );
			else
				put_output( "Warning: ", 0 );
		}
		beginning_of_line();
		point+=21;
		parse_string( 1, "...", d );
		if( opCode != 2 || 0 == strcmp( "   ", d ))
			putName(0);
		else
			put_expOrInitAtD();

		put_output( "\n", 0 );
		indentLevel = savedIndentLevel;
		break;

	case 1:		//Select
		savedIndentLevel = indentLevel;
		putCondition(0,1);
		beginning_of_line();
		point+=12;
		put_output( curchar() == 'R'?"Real:":"Virt:", 0);
		putName(0);
		if( hasInit()){
			putEqualSign();
			putExpOrInit();
		}
		else
			put_output( "\n", 0 );
			
		indentLevel = savedIndentLevel;
		break;
	case 60: // task start
		expressionsPoint = 0; //fall through to combined task/operations code
		exptablePoint = 0;
		operationsString[0] = '\0';
		savepoint = point;
		if( re_search( 1, "^ Expressions Table:" ))
			exptablePoint = point;
		if( re_search( 1, "^ Translated Expressions:" ))
			expressionsPoint = point;
		
		point = savepoint;
		indentLevel = 1;
		put_output( "\n", 0 );
		from = point;
		end_of_line();
		point--; //don't want to see the vertical bar.
		xfer_out( from, point, 0);	// copy to other buffer
		put_output( "\n--------------------------------------------------\n", 0 );
		if( re_search( 1, "^ Operations:" )){
			iter = 1;
			up_line();
		}
		break;
			
	case 61: // operations
		savepoint = point;
		parse_string( 1, ".+$", d ); //pick up the operations string
		point = savepoint;
		if( 0 != strcmp( operationsString, d )){
			strcpy( operationsString, d );
			indentLevel = 1;
			put_output( "\n", 0 );
			from = point;
			end_of_line();
			xfer_out( from, point, 0);	// copy to other buffer
			put_output( "\n", 0 );
		}
		break;

	case 88://Parameter
		beginning_of_line();
		point+=16;
		parse_string( 1, "....", d ); //pick up the parameter number
		if( 0 != strcmp( "   ", d )){
			indentLevel+=2;
			put_output( d, 1 );	// print the parameter number and bar
			if( curchar() == '?' ){
				point+=4;
				parse_string( 1, "...", d ); //pick up the expression 
				put_expOrInitAtD();
			}
			else{
				isParameter = 1;
				putName(0);
				isParameter = 0;
				put_output( "\n", 0 );
			}
			indentLevel-=2;
		}
		break;

	case 5:		// Block
		putCondition(1,0);
		break;

	case 6:		// End Block
		clearCondition();
		break;

	case 8:		// Evaluate Exp
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		
		beginning_of_line();
		point+=68;
		if( curchar() != '?' ){
			parse_string( 1, "..", d );
			copyVarNameToOutput();
			putEqualSign();
		}
		beginning_of_line();
		point+=21;
		parse_string( 1, "...", d );
		put_expOrInitAtD();
		indentLevel = savedIndentLevel;
		break;

	default:		//default - handles comments
		//putLine(); //from beginning
		//put_output( "\n", 0 );
		break;
	}
	rfrsh();
	iter = 1;
	down_line();
	if( point == endpoint )
		return(0);
	
	beginning_of_line();
	point++;
	parse_string(1, "[a-zA-Z0-9_:]+", d);
	if( 0 == strcmp( d, "Forms:" )){ //can skip ahead to task:
		if( re_search( 1, " Task Name: " )){
			iter = 1;
			up_line();
		}
	}
	return(1);
}
inits()
{
	re_search( -1, "Task Name: " );
	margin_right = 1000;
	expressionsPoint = 0;
	exptablePoint = 0;
	isParameter = 0;
	indentLevel = 1;
	indentExp[0] = '\0';
	strcpy( mainBufName, bufname);
	strcpy( outputBufName, "MagicEzRead");
	mainBufNum = bufnum;
	vertBarString[0] = VERTBAR;
	vertBarString[1] = '\0';
	zap(outputBufName);
	to_buffer( outputBufName );
	outputBufNum = bufnum;
	stuff( "Magic Source Translation - Version 1.0   6/14/96" );
	bprintf( "  w\\Lugaru's Epsilon %s\n\n", version );
	to_buffer( mainBufName );
	savepoint = point;
	goto_end();
	endpoint = point;
	point = savepoint;
}
command magic_doc_translate() on reg_tab[FKEY(12)]
{
	translate_magic_doc();
}
command translate_magic_doc() 
{
	int i;
	int spin = 0;
	TIMER t;
	int initTime = 32000;

	suppress_dings = iter;
	iter = 0;
	time_begin( &t, initTime );
	inits();
	for (i = 1; ; i++){
		if(!doNext())
			break;
#ifndef DEBUG 
		if( i%10 == 0){
			note( "%c %d%%", spinString[spin], 100*point/endpoint);
			spin = (spin+1)%8;
		}
#endif
	}
	note( "100%%" );
	to_buffer( outputBufName );
	goto_beginning();
	iter = 1;
	down_line();
	bprintf( "***Elapsed Time: %d seconds\n", (initTime - time_remaining( &t))/100 );
	to_buffer( mainBufName );
	note( "Done" );
	if( !suppress_dings ){
		ding();
		ding();
		ding();
	}
	margin_right = 78;
	refresh();
}    
command magic_doc_translate() 
{
	translate_magic_doc();
}

command run_magic_doc_translate_and_exit()
{
	char outfile[100];
	char len;
	char *p;

	iter = 1;
	translate_magic_doc();
	p =  strstr( filename, "." );
	if( !p )
		p = "";
	len = strlen( filename ) - strlen( p );
	strcpy( outfile, filename );
	strcpy( &outfile[len], ".ezr" );
	to_buffer( outputBufName );
	file_write( outfile, 0 );
	iter =1;
	exit();
}
