/*
*	mgtrans.e - Translate Magic PC v5.70 exported doc files.
*	Version 16
*
*	This source file is the source of a compiled macro that runs under
*	the Epsilon (see note) text editor.
*
*	Incorporating the macro into Epsilon:
*	-------------------------------------
*	
*	Run the Epsilon macro compiler at a dos prompt to compile this file
*	to 'mgtrans.b'.
*		'\epsilon\bin\eel -ic:\eps700\include mgtrans.e'
*		'c:\eps\bin\eel -ic:\eps\include mgtrans.e'
*
*	Then start epsilon and run the epsilon command 'load-bytes' supplying
*	'mgtrans.b'	(without quotes) to load the macro into the text editor.
*	Run the command 'write-state' so that the next time epsilon is loaded the
*	load-bytes command will not need to be run.
*
*   Note: "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. 
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	
*
*	Using the macro:
*	----------------
*	Use doc_std.ira to export a Magic program as a document output file.
*	Load the export file into the Epsilon text editor. 
*	Translation begins at the cursor, so to translate the whole file,
*	   make sure cursor is at the beginning of file.
*	Run the command translate-magic-doc.
*	View the translated output in the buffer MagicEzRead.
*
*	Created:
*		06/14/96 Ira Gershenhorn 
*	
*	Updated:
*		06/17/96 IG Add task range and end task expressions.        
*		            Add select range and locate expressions.
*		            Add Link statemend.
*		06/19/96 IG Speed ups
*		06/19/96 IG Full support for In/Output Forms
*		06/20/96 IG Replaced fill_paragraph w/replace "\n and 5 spaces"
*		06/30/96 IG Fix exit on expression
					Add comments
		07/01/96 IG Add idle time task id.
		07/02/96 IG Buffer name is derived from original filename by tacking
					 on '.ezr'
		01/20/97 IG Date stamp the first task with the run date.
*        
*/
#include "eel.h"
int firstTask=1;
struct time_info ts;
int save_undo_size;
int suppress_dings;
int VARsExist;
int savepoint, from, to, endpoint, expressionsPoint, exptablePoint, outmark, brkLevelTablePoint;
int IOFilesPoint, DBFilesPoint;
int lineStart;
char spinString[]="|/-\\|/-\\";

int formsPoint[100];
int formMark;
int ioPoint[20];
int ioExp[20];

char d[80];
char d2[80];
char operationsString[100];

char ss[20]; //searchstring
char outputBufName[40];
char taskName[40];
int	outputBufNum;
char mainBufName[40];
int mainBufNum;

int isParameter;
int indentLevel;
char indentExp[255];
int done;

int	save_case_fold;
int	save_margin_right;

jmp_buf quick_exit;

#define SPACE 0x20

//#define DEBUG
//#define ShowRefresh

rfrsh()
{
#ifdef ShowRefresh
	refresh();
	center_window();
#endif	
}

tab_in()
{
	int i;
	
	for( i= 0; i<indentLevel; i++ )
		stuff( "\t" );
}
xfer_out(from, to, prev )
{
	window_bufnum = outputBufNum;
	outmark = point;
	window_bufnum = mainBufNum;
	raw_xfer(outputBufNum, from, to);	// copy to other buffer
	window_bufnum = outputBufNum;
	if( prev )
		point--;
	delete_horizontal_space();
	if( prev )
		point++;
	window_bufnum = mainBufNum;
}
put_output( s, tabbed, back )
char *s;
{
	window_bufnum = outputBufNum;
	point -= back;
	outmark = point;
	if( tabbed )
		tab_in();
	if( strlen( s))
		stuff( s );
	if( back )
		goto_end();
	
	window_bufnum = mainBufNum;
}
printPoint()
{
	char s[15];
	
	sprintf( s, " point:%d ", point);
	put_output( s, 0, 0 );
}
del_horiz_space_in_output()
{
	window_bufnum = outputBufNum;
	delete_horizontal_space();
	window_bufnum = mainBufNum;
}
copyVarNameToOutput()
{
	int spoint;
	
	spoint = point;
	point = exptablePoint;
	sprintf( ss,"%s%s","^",d );

	if( re_search( 1, ss )){ //search for field code
		xfer_out(point+1, point+21, 0);
	}
	point = spoint;
}
expandVARs_and_fill()
{
	int expBegin;
	
	window_bufnum = outputBufNum;
	expBegin = outmark;
	if( VARsExist ){
		point = outmark;
		if( search(1, "'VAR" )){
			point = outmark;
			while( 1 ){
				if( !re_search( 1, "'[A-Z][A-Z]'VAR|'[A-Z]'VAR" ))
					break;
				mark = point;
				point = matchstart+1;
				grab( point, point+2, d );
				if( d[1]=='\'' )
					d[1]=SPACE;

				point = matchstart;//-1;
				delete( point, mark );
				stuff( "@" );
				window_bufnum = mainBufNum;
				copyVarNameToOutput();

				window_bufnum = outputBufNum;
			}
		}
	}
	goto_end();
	mark = point-1;
	point = expBegin;

	narrow_start = point;
	narrow_end = size() - mark;

	while( re_search( 1, "^     " )){// 5 spaces
		delete( matchstart-1, matchend );
	}
	narrow_start = narrow_end = 0;
	goto_end();
	window_bufnum = mainBufNum;
}
putExpressionAtPoint()
{
	from = point+1;
	done = 0;
	while( !done ){
		iter = 1;
		down_line();
		beginning_of_line();
		to = point;
		if( character(point+3) != SPACE )// if SPACE, then a continuation line
			done = 1;
	}
	xfer_out(from, to, 1 );
	expandVARs_and_fill();
}
put_expOrInitAtD()
{
	int spoint;
	
	spoint = point;
	point = expressionsPoint;
	sprintf( ss,"%s%s","^ ",d );
	if( re_search( 1, ss )){ //search for expression number
		rfrsh();
		putExpressionAtPoint();
	}
	point = spoint;
}
// Gets the condition, and if not YES, inserts and increases indent level.
// while saving previous level.
// If a new condition is evaluated to be same as previous the indent level is left
// as is. Otherwise, it is restored to the previous level.
putCondition( block, isSelect )
{
	int savedIndent;
	
	put_output( "", 1 ,0 );
	
	end_of_line();
	search( -1, "" );
	search( -1, "" );
	point++;
	grab( point, point+3, d );
	if( 0 == strcmp( d, "Yes" )){
		if( block ){
			put_output( "Do\n", 0 , 0);
			strcpy( indentExp, "Yes" );
			indentLevel++;
		}
		else
			indentExp[0] = '\0';
	}
	else {
		if( 0 != strcmp( indentExp, d )){ //don't repeat 'if' if the same as previous
			if( 0 ==strcmp( d, "No " )){
				if( isSelect )
					put_output( "Never do/Land on fields:\n", 0 , 0);
				else
					put_output( "Never do:\n", 0 , 0);
			}
			else {
				put_output( "If ", 0 , 0);
				put_expOrInitAtD();
			}
			strcpy( indentExp, d );
			indentLevel++;
			if( !block )
				put_output( "", 1 , 0);
		}
		else {
			if( !block ){
				savedIndent = indentLevel;
				indentLevel = 1; // only want one additional tab
				put_output( "", 1 , 0);
				indentLevel = savedIndent;
			}
			indentLevel++;
		}
	}
	rfrsh();
}
putIOFile()
{
	int n;

	point = lineStart + 51;
	re_search( 1, "[0-9]" );
	point--;
	parse_string( 1, "[0-9]+", d );
	
	if( 0 == strncmp( "  0", d, 3 ))
		return;
	n = strtoi( d, 10 );

/*	if( ioPoint[n] == -1 )
		return;
	else if( ioPoint[n] )
		point = ioPoint[n];
	else {
*/
		point = lineStart + 51;
		rfrsh();
		grab( point, point+3, d );
		point+=3;
		if( 0 == strcmp( "  0", d )){
			ioPoint[n] = -1;
			return;
		}
		rfrsh();

		if( !re_search( -1, "^ IO Files:" )){
			ioPoint[n] = -1;
			return;
		}
		rfrsh();
		sprintf( ss, "^%s", d );
		if( !re_search( 1, ss )){
			ioPoint[n] = -1;
			return;
		}
		beginning_of_line();
		rfrsh();
		grab( point, point+27, d2 );
		sprintf( d, "\n%s", d2 );
		point = 0;
		if( !search( 1, d ) ){
			ioPoint[n] = -1;
			return;
		}
		rfrsh();
		beginning_of_line();
		ioPoint[n] = point; // now we find the first instance of this declaration
		point += 65;
		grab( point, point+3, d );
		if( 0 == strcmp( "  0", d ))
			return;

		sprintf( ss,"%s%s","^ ",d );
		if( re_search( 1, ss )) //search for expression number
			ioExp[n] = point;
//	}
	if( !ioPoint[n] )
		return;
	
	put_output( " ON ", 0 , 0);
	point = ioPoint[n];
	from = point+5;
	end_of_line();
	xfer_out( from, point, 0);
	if( !ioExp[n] )
		return;

	put_output( " FILE: ", 0 , 0);
	point = ioExp[n];
	putExpressionAtPoint();
}
putFormName()
{
	int n;

	point = lineStart + 21;
	re_search( 1, "[0-9]" );
	point--;
	parse_string( 1, "[0-9]+", d );
	
	if( 0 == strncmp( "  0", d, 3 ))
		return;
	n = strtoi( d, 10 );

	if( formsPoint[n] )
		point = formsPoint[n];
	else {
		point = lineStart + 21;
		strcpy( d, "\n" );
		grab( point, point+24, &d[2] );
		
		point = 0;
		if( search( 1, d ))
			formsPoint[n] = point;
	}
	if( formsPoint[n] ){
		beginning_of_line();
		xfer_out(point+5, point+35, 0);
	}
}
putFlowComment( backup )
{
	char interactionMode = character( lineStart + 71);
	char cursorDirection = character( lineStart + 73);

	if( interactionMode == ' ')
		return;
	switch(interactionMode){
		case 'S':
			put_output( "\t// Step", 0, backup);
			break;
		case 'F':
			put_output( "\t// Fast", 0, backup);
			break;
		case 'C':
			put_output( "\t// Combined", 0, backup);
			break;
		case 'B':
			put_output( "\t// on Zoom (Before)", 0, backup  );
			break;
		case 'A':
			put_output( "\t// on Zoom (After)", 0, backup  );
			break;
		default:
			put_output( "\t// unknown mode", 0, backup  );
			break;
	}
	switch(cursorDirection){
		case 'F':
			put_output( " forward", 0, backup);
			break;
		case 'C':
			put_output( " forward,back", 0, backup);
			break;
		case 'B':
			put_output( " backwards", 0, backup);
			break;
		default:
			put_output( " unknown dir", 0, backup  );
			break;
	}
}
putName()
{
	int save = point;
	
	point = lineStart + (isParameter?28:25);
	xfer_out(point, point+20, 0 );	// copy to other buffer
	point = save;
}
putDisplayItems( start, end )
{
	narrow_end = size() - end;

	point = start;
	
	if( re_search( 1, "^ Display Items:" )){
		put_output( "\nDisplay Items\n", 0 , 0);
		nl_forward();
		raw_xfer(outputBufNum, point+14,point+84);
		put_output( "\n",0 , 0);
		while( re_search( 1, "^" )){
			point -= 2;
			if( character(point+6) != ' ' ) // Field filled by Variable
				raw_xfer(outputBufNum, point+14,point+88);
			else { // Field is filled by Expression
				grab( point+10, point+13, d );
				put_expOrInitAtD();
				put_output( "  See above expr.    ", 0 , 0);
				raw_xfer(outputBufNum, point+34,point+88);
			}
			put_output( "\n",0 , 0);
			// Check for Allow Input expression
			if( character(point+78) != 'Y' &&
				character(point+78) != 'N'
			  ){ 
				put_output( "\tAllow input when: ",0 , 0);
				grab( point+78, point+81, d );
				put_expOrInitAtD();
				put_output( "\n",0 , 0);
			}
			// Check for Must Input expression
			if( character(point+83) != 'Y' &&
				character(point+83) != 'N'
			  ){ 
				put_output( "\tMust input when: ",0 , 0);
				grab( point+83, point+86, d );
				put_expOrInitAtD();
				put_output( "\n",0 , 0);
			}
			nl_forward();
		}
	}
	goto_end();
	narrow_end = 0;
}
// clearCondition decreases indent level and erases memory of the condition string
clearCondition()
{
	indentLevel--;
	indentExp[0]='\0'; // is this necessary?
}

int getOperationCode()
{
	//assumes we are at the beginning of the line
	if( character( point + 4 ) == '' ){
		if( character( point+5) == '' ) // empty line
			return( 99 );
		if( character( point + 24 ) != '' )
			return( 98 ); //comment

		point += 5;

		parse_string(1, "[a-zA-Z]+", d);

		if     ( 0 == strcmp( d, "Select" ))
			return( 1 );
		else if( 0 == strcmp( d, "Update" ))
			return( 9);
		else if( 0 == strcmp( d, "Block" ))
			return( 5);
		else if( 0 == strcmp( d, "End" )){
			point++;
			parse_string(1, "[a-zA-Z]+", d);
			if( 0 == strcmp( d, "Block" ))
				return( 6);
			else
				return( 0 );
		}
		else if( 0 == strcmp( d, "Link" ))
			return( 3 );
		else if( 0 == strcmp( d, "Call" )){
			point++;
			parse_string(1, "[a-zA-Z]+", d);
			if( 0 == strcmp( d, "Program" ))
				return( 7);
			else
				return( 71);
		}
		else if( 0 == strcmp( d, "Output" ))
			return( 10 );
		else if( 0 == strcmp( d, "Input" ))
			return( 11 );
		else if( 0 == strcmp( d, "Verify" ))
			return( 2 );
		else if( 0 == strcmp( d, "Exit" ))
			return( 13  );
		else if( 0 == strcmp( d, "Evaluate" ))
			return( 8 );
		else
			return( 0 );
	}

	else {
		re_search( 1, "[A-Z]" );
		point--;
/*		
		parse_string(1, "[PFTO]", d);
		if( d[0] == '\0')
			return(0);
		point--;
*/		
		parse_string(1, "[a-zA-Z:]+", d);
		if( 0 == strcmp( d, "Parameter:" ))
			return( 88 );

		if( 0 == strcmp( d, "Forms:" )){ //can skip ahead to task:
			mark = point;
			if( re_search( 1, "Task Name: " )){
				putDisplayItems( mark, point );
				return( 60 );
			}
			else {
				goto_end();
				putDisplayItems( mark, point );
			}
			return( 0 ); // just call here again
		}
		if( 0 == strcmp( d, "Operations:" ))
			return( 61 );
		if( 0 == strcmp( d, "Task" )){
			point++;
			parse_string(1, "[a-zA-Z:]+", d);
			if( 0 == strcmp( d, "Name:" ))
				return( 60 );
			else
				return( 0 );
		}
		else
			return( 0 );
	}
}
putLine()
{
	end_of_line();
	raw_xfer(outputBufNum, lineStart, point);	// copy to other buffer
}
srch_and_put( s, x )
char *s;
{
	int y;

	y = point;
	search( 1, s );
	if( point > y && point < expressionsPoint ){
		put_output( "\n", 0 , 0);
		put_output( s, 0 , 0);
		if( x > 0 )
			xfer_out( point, point+x, 0);	// copy to other buffer
		else {
			grab( point, point+3, d );

			if(		( 0 == strcmp( d, "Yes" )) ||
					( 0 == strcmp( d, "No " ))
			)
				put_output( d, 0 , 0);
			else if( 0 == strcmp( d, "  0" ))
				put_output( "None Defined", 0 , 0);
			else 
				put_expOrInitAtD();
		}
	}
	else
		point = y;
}
doNext()
{
	int opCode, savedIndentLevel;

	//assumes we are beginning of line
	lineStart = point;
	opCode = getOperationCode();
	switch (opCode) {
	case 1:		//Select
		savedIndentLevel = indentLevel;
		putCondition(0,1);
		point =lineStart + 12;
		put_output( curchar() == 'R'?"Real:":"Virt:", 0, 0);
		putName();
		//point = lineStart + 51;
		grab( lineStart+51, lineStart+54, d );

		if( 0 ==strcmp( d, "  0" ))
			put_output( "\n", 0 , 0);
		else {
			put_output( "\t= ", 0 , 0);
			put_expOrInitAtD();
		}
		putFlowComment( 1 );
		//check if any range or locate expressions
		narrow_start = point = lineStart+55;
		narrow_end = size() - (lineStart+70);
		
		if( re_search( 1, "[1-9]" )){
			narrow_start = narrow_end = 0;
			//check range
			indentLevel++;
			grab( lineStart+55, lineStart+58, d );
			if( 0 !=strcmp( d, "  0" )){
				put_output( "Range From: ", 1 , 0);
				put_expOrInitAtD();
			}
			grab( lineStart+59, lineStart+62, d );
			if( 0 !=strcmp( d, "  0" )){
				put_output( "Range   To: ", 1 , 0);
				put_expOrInitAtD();
			}
			//check locate
			grab( lineStart+63, lineStart+66, d );
			if( 0 !=strcmp( d, "  0" )){
				put_output( "Locate From: ", 1 , 0);
				put_expOrInitAtD();
			}
			grab( lineStart+67, lineStart+70, d );
			if( 0 !=strcmp( d, "  0" )){
				put_output( "Locate   To: ", 1 , 0);
				put_expOrInitAtD();
			}
		}			
		narrow_start = narrow_end = 0;
		indentLevel = savedIndentLevel;
		break;

	case 98:// comment line
	case 99:// blank line
		put_output( "//", 1 , 0);
		xfer_out( lineStart+5, lineStart+78, 0);
		put_output( "\n", 0 , 0);
		break;
			
	case 9:		// update Var:
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		putName();
		put_output( "\t= ", 0 , 0);
		grab( lineStart+51, lineStart+54, d );
		put_expOrInitAtD();
		putFlowComment( 1 );
		indentLevel = savedIndentLevel;
		break;

	case 5:		// Block
		putCondition(1,0);
		putFlowComment( 1 );
		break;

	case 6:		// End Block
		clearCondition();
		break;

	case 88://Parameter
		point = lineStart + 16;
		grab( point, point+4, d );
		point+=4;
		if( 0 != strcmp( "   ", d )){
			indentLevel+=2;
			d[3]= '\0'; // chop the bar off
			put_output( d, 1 , 0);	// print the parameter number 
			put_output( "|", 0 , 0);
			if( curchar() == '?' ){
				point+=4;
				grab( point, point+3, d );
				point += 3;
				put_expOrInitAtD();
			}
			else{
				isParameter = 1;
				putName();
				isParameter = 0;
				put_output( "\n", 0 , 0);
			}
			indentLevel-=2;
		}
		break;

	case 7: //Call Program:
	case 71:// Call Task:
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		point = lineStart + 10;
		if( curchar() == 'P' )
			put_output( "Call Prog: ", 0 , 0);
		else
			put_output( "Call Task: ", 0 , 0);
		putName();
		putFlowComment( 0 );
		put_output( "\n", 0 , 0);
		indentLevel = savedIndentLevel;
		break;

	case 3:// Link:
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		point = lineStart + 68;
		if( curchar() != '?' ){
			grab( point, point+2, d );

			copyVarNameToOutput();
			put_output( "\t= ", 0 , 0);
		}
		point = lineStart + 5;
		xfer_out( point, point+57, 0);	// get link, type, filename,key, ascending/descending flag
		put_output( "\n", 0 , 0);
		indentLevel = savedIndentLevel;
		break;

	case 11:// Input Form
	case 10:// Output Form
		savedIndentLevel = indentLevel;
		putCondition(0,0);

		if( opCode == 11 )
			put_output( "Input Form: ", 0 , 0);
		else
			put_output( "Output Form: ", 0 , 0);

		savepoint = point;
		putFormName();
		point = savepoint;
		putIOFile();
		point = savepoint;
		//putName();
		put_output( "\n", 0 , 0);
		indentLevel = savedIndentLevel;
		break;

	case 13:// Exit on Exp:
	case 2:	// Verify Exp:
		savedIndentLevel = indentLevel;
		putCondition(0,0);

		if( opCode == 13 )
			put_output( "Exit to: ", 0 , 0);
		else if( opCode == 2 ){
			if(character( lineStart +53 ) == 'E' )
				put_output( "Put Error: ", 0 , 0);
			else
				put_output( "Put Warning: ", 0 , 0);
		}
		grab( lineStart+21, lineStart+24, d );

		if( 0 == strcmp( "   ", d ))
			putName();
		else
			put_expOrInitAtD();

		putFlowComment( 0 );
		put_output( "\n", 0 , 0);
		indentLevel = savedIndentLevel;
		break;

	case 60: // Task Start:
		expressionsPoint = 0;
		exptablePoint = 0;
		operationsString[0] = '\0';
		
		indentLevel = 1;
		put_output( "\nTask Name: ", 0 , 0);
		from = point;
		grab( point, point+35, taskName );
		end_of_line();
		point--; //don't want to see the vertical bar.
		xfer_out( from, point, 0);	// copy to other buffer
		if(	firstTask ){
			char date[20];

		    sprintf( date,"  %d/%d/%d", ts.month, ts.day, ts.year);
			put_output( date, 0 , 0);
			firstTask = 0;
		}
		put_output( "\n--------------------------------------------------\n", 0 , 0);

		//------------------------------------------
		savepoint = point;
		re_search( 1, "^ Break Level:" );
		brkLevelTablePoint = point;

		point = savepoint;
		narrow_start = point;
		narrow_end = size() - brkLevelTablePoint;

		re_search( 1, "^ Expressions Table:" );
		exptablePoint = point;

		re_search( 1, "^ Translated Expressions:" );
		expressionsPoint = point;
		narrow_start = narrow_end = 0;

		point = savepoint;
		
		//------------------------------------------
		search( 1, "Main File: " );
		point = matchstart;
		xfer_out( point, point+45, 0);	// copy to other buffer
		search( 1, "Key: " );
		put_output( "  Key: ", 0 , 0);
		xfer_out( point, point+25, 0);	// copy to other buffer

		search( 1, "Key Exp: " );
		grab( point, point+3, d );

		if( 0 != strcmp( d, "   " )){
			put_output( "\nKey Exp: ", 0 , 0);
			put_expOrInitAtD();
		}

		search( 1, "Task Type: " );
		point = matchstart;
		put_output( "\n", 0 , 0);
		xfer_out( point, point+20, 0);	// copy to other buffer

		search( 1, "Initial Mode: " );
		point = matchstart;
		put_output( "\n", 0 , 0);
		xfer_out( point, point+20, 0);	// copy to other buffer
		search( 1, "Initial Mode Exp: " );
		grab( point, point+3, d );

		if( 0 != strcmp( d, "   " )){
			put_output( "\nInitial Mode Exp: ", 0 , 0);
			put_expOrInitAtD();
		}

		srch_and_put( "Selection Table: ", 0 );
		srch_and_put( "Resident Task: ", 0 );

		put_output( "\n\n//Task Control\n", 0 , 0);

		savepoint = point;
		srch_and_put( "Open Task Window: ", 0 );
		srch_and_put( "Close Task Window: ", 0 );
		srch_and_put( "Foreground Window: ", 0 );
		srch_and_put( "Refresh Task Window: ", 0 );
		srch_and_put( "Flip Field on Input: ", 0 );
		srch_and_put( "Cycle Record Main: ", 0 );
		srch_and_put( "Confirm Update: ", 0 );
		srch_and_put( "Form Records: ", 5 );
		put_output( "\n", 0 , 0);
		point = savepoint;
		srch_and_put( "Locate Exp: ", 0 );
		srch_and_put( "Locate Order: ", 15 );
		srch_and_put( "Range Exp: ", 0 );
		srch_and_put( "Range Order: ", 15 );
		srch_and_put( "End Task: ", 0 );
		srch_and_put( "End Check: ", 15 );
		srch_and_put( "Force Record Suffix: ", 0 );
		srch_and_put( "Force Record Delete: ", 0 );
		put_output( "\n", 0 , 0);
		srch_and_put( "Locking Strategy: ", 10 );
		srch_and_put( "On Locked Record : ", 10 );
		srch_and_put( "On Failed Record Access: ", 10 );
		put_output( "\n\n//Options Control\n", 0 , 0);

		srch_and_put( "Allow Options: ", 0 );
		srch_and_put( "Allow Modify: ", 0 );
		srch_and_put( "Allow Create: ", 0 );
		srch_and_put( "Allow Delete: ", 0 );
		srch_and_put( "Allow Query: ", 0 );
		srch_and_put( "Allow Locate: ", 0 );
		srch_and_put( "Allow Range: ", 0 );
		srch_and_put( "Allow Key Change: ", 0 );
		srch_and_put( "Allow Sorting: ", 0 );
		srch_and_put( "Allow I/O Files: ", 0 );
		srch_and_put( "Allow Abort: ", 0 );
		srch_and_put( "Allow Key Optimization: ", 0 );
		srch_and_put( "Allow Locate in Query: ", 0 );
		srch_and_put( "Allow Reports: ", 0 );

		put_output( "\n\n//Task Levels\n", 0 , 0);

		savepoint = point;
		re_search( 1, "^ DB Files:" );
		DBFilesPoint = point;

		point = savepoint;
		re_search( 1, "^ IO Files:" );
		IOFilesPoint = point;

		point = savepoint;
		// Check for the Virtual Fields table using the Break Level Table string as the furthest point to search to.
		narrow_start = point;
		narrow_end = size() - brkLevelTablePoint;
		if(	re_search( 1, "^ Virtual Fields:" )){
			int limitPoint;

			limitPoint = DBFilesPoint;
			if( IOFilesPoint < limitPoint )
				limitPoint = IOFilesPoint;
			if( exptablePoint < limitPoint )
				limitPoint = exptablePoint;
			
			beginning_of_line();
			savepoint = point;
			iter = 2;
			down_line();
			xfer_out( savepoint-1, point, 0);	// copy to other buffer
			while( point < limitPoint )
			/*while( point < DBFilesPoint &&
				   point < IOFilesPoint &&
				   point < exptablePoint
			)*/{
				if( character( point ) == '' ){
					xfer_out( point, point+72, 0);	// copy to other buffer
					put_output( "\n", 0 , 0);
				}
				iter = 1;
				down_line();
			}
		}
		iter = 1;
		up_line();

		point = savepoint;
		// Check for the DB Files table using the Break Level Table string as the furthest point to search to.
		if(	re_search( 1, "^ DB Files:" )){
			int limitPoint;

			limitPoint = exptablePoint;
			if( IOFilesPoint < limitPoint )
				limitPoint = IOFilesPoint;

			narrow_start = narrow_end = 0;
			beginning_of_line();
			savepoint = point;
			iter = 2;
			down_line();
			xfer_out( savepoint-1, point, 0);	// copy to other buffer
			while( point < limitPoint )
			/* while( point < IOFilesPoint &&
				   point < exptablePoint
			)*/{
				if(character( point + 2 ) == '' ){
					xfer_out( point, point+53, 0);	// copy to other buffer
					grab( point+53, point+56, d );
					if( 0 == strcmp( d, "  0" ))
						put_output( "None Defined\n", 0 , 0);
					else {
						put_expOrInitAtD();
					}
				}
				iter = 1;
				down_line();
			}
		}
		narrow_start = narrow_end = 0;
		iter = 1;
		up_line();

		if( re_search( 1, "^ Operations:" )){
			iter = 1;
			up_line();
			narrow_start = savepoint;
			narrow_end = size() - point;
			point = narrow_start;
			VARsExist = re_search( 1, "'[A-Z][A-Z]'VAR|'[A-Z]'VAR" );
			goto_end();
			narrow_start = narrow_end = 0;
		}
		break;
			
	case 61: // operations
		savepoint = point;
		parse_string( 1, ".+$", d ); //pick up the operations string
		point = savepoint;
		if( 0 != strcmp( operationsString, d )){
			strcpy( operationsString, d );
			indentLevel = 1;
			put_output( "\nOperations:", 0 , 0);
			from = point;
			end_of_line();
			xfer_out( from, point, 0);	// copy to other buffer
			put_output( "\n", 0 , 0);
		}
		break;

	case 8:		// Evaluate Exp
		savedIndentLevel = indentLevel;
		putCondition(0,0);
		
		point = lineStart + 68;
		if( curchar() != '?' ){
			grab( point, point+2, d );
			copyVarNameToOutput();
			put_output( "\t= ", 0 , 0);
		}
		point = lineStart + 21;
		grab( point, point+3, d );

		put_expOrInitAtD();
		putFlowComment( 1 );
		indentLevel = savedIndentLevel;
		break;

	default:		
		break;
	}
	iter = 1;
	down_line();
	if( point == endpoint )
		return(0);
	
	beginning_of_line();
	rfrsh();
	return(1);
}
create_ezr_name( d, rel )
char *d;
{
	char len;
	char s[100];
	char *p;
	
	if( rel )
		strcpy( s, get_tail(filename, 0));
	else
		strcpy( s, filename );

	p =  strstr( s, "." );
	if( !p )
		p = "";
	len = strlen( s ) - strlen( p );
	strcpy( d, s );
	strcpy( &d[len], ".ezr" );
}
inits()
{
	int i;
	char outfile[100];

	save_undo_size = undo_size;
	undo_size = 0;
	save_case_fold = case_fold;

	for( i=1; i<100; i++){
		formsPoint[i] = 0;
		if( i < 20 ){
			ioPoint[i] = 0;
			ioExp[i] = 0;
		}
	}
	
	re_search( -1, "Task Name: " );
	case_fold = 0;
	expressionsPoint = 0;
	exptablePoint = 0;
	isParameter = 0;
	indentLevel = 1;
	indentExp[0] = '\0';

	strcpy( mainBufName, bufname);
	mainBufNum = bufnum;
	create_ezr_name( outfile, 1 );

	strcpy( outputBufName, outfile );
	zap(outputBufName); 
	
	to_buffer( outputBufName );
	outputBufNum = bufnum;
	undo_size = 0;
	undo_flag = 0;
	stuff( "Magic Source Translation - Version 1.0.16  03/25/97" );
	bprintf( "  w\\Lugaru Epsilon %s\n\n", version );

	window_bufnum = mainBufNum;
	savepoint = point;
	goto_end();
	endpoint = point;
	point = savepoint;
}
command magic_doc_translate() on reg_tab[FKEY(12)]
{
	if( !setjmp( &quick_exit ))
		translate_magic_doc();
}
command translate_magic_doc() 
{
	int i;
	int spin = 0;
	TIMER t;
	int initTime = 32000;

	suppress_dings = iter;
	iter = 0;

    time_and_day(&ts);
	time_begin( &t, initTime );
	inits();
	beginning_of_line();
	for (i = 1; ; i++){
		if(!doNext())
			break;
#ifndef DEBUG 
		if( i%50 == 0){
			note( "%c %d%% %s", spinString[spin], 100*point/endpoint, taskName);
			spin = (spin+1)%8;
		}
#endif
	}
	note( "100%%" );
	window_bufnum = outputBufNum;
	point = 0;
	iter = 1;
	down_line();
	bprintf( "***Elapsed Time: %d seconds\n", (initTime - time_remaining( &t))/100 );
	string_replace( "", " ", 0 );// replace all vertical bars with SPACE
	point = 0;
	window_bufnum = mainBufNum;
	note( "Done" );

	case_fold	= save_case_fold;
	undo_size	= save_undo_size;

	if( !suppress_dings ){
		ding();
		ding();
		ding();
	}
	refresh();
}    
command magic_doc_translate() 
{
	translate_magic_doc();
}
command run_magic_doc_xlate()
{
	char outfile[100];

	iter = 1;
	translate_magic_doc();
	create_ezr_name( outfile, 0 );
	window_bufnum = outputBufNum;
	file_write( outfile, 0 );
	iter =1;
	exit();
}
zeroed TIMER idle_display_time;
when_idle(cnt)		// called when there's nothing to do, waiting for key
{
	when_idle_coloring(cnt);
	if (cnt > 0 && !time_done(&idle_display_time))
		return;
	if (!_doing_input && !_doing_completion  && !cmd_len){
		if( 0 != strstr( bufname, ".ezr" ))
			note_current_task();
		else
			strcpy( mode_start, "" );

		make_mode();
	}
	time_begin(&idle_display_time, 100);	// 10 times a second
}
replace_chars( s, chars )
char *s, *chars;
{
	int len, i;
	char *d;

	len = strlen( chars );
	for( i=0; i<len; i++ ){
		d = s;
		while( d = index(d, chars[i]))
			d[0] = '_';
	}
}
/*command replace_in_region()
{
	grab( mark, point, d);
	replace_chars( d, "(){}" );
	stuff( d );
}
*/
command note_current_task()
{
	int savepoint = point;
	int sp;
	char dd[100];

	if( re_search( -1, "^Task Name: " )){
		sp = matchstart;
		search( 1, "\n" );
		grab( sp, point-1, dd );
		if(strlen( dd) >27 )
			dd[27] = '\0';
		replace_chars( dd, "()%" );
		strcat( dd, " " );
	}
	else
		strcpy( dd, "" );
	
	strcpy( mode_start, dd );
	//strcat( mode_start, " " );
	strcpy(mode_end, " %d%p %s %l %c");
			
	point = savepoint;
}
command sum_region() on reg_tab[FALT(12)]
{
	int spoint = point;
	int sum = 0;
	int end, sign;
	
	if( mark > point ){
		point = mark;
		mark = spoint;
	}
	point = mark;
	while( re_search( 1, "%-?[0-9]+%.?[0-9]+" )){
		point = matchstart;
		end = matchend;
		if( curchar() == '-' ){
			sign = -1;
			point++;
		}
		else
			sign = 1;
		
		parse_string( 1, "[0-9]+", d );
		sum += sign * strtoi( d, 10 );
		point = end;
	}
	point = spoint;
	bprintf( "%d", sum );
}
suffix_ezr()
{
	c_mode();
//	c_extra_keywords = 0;	// don't recognize C++ or EEL keywords in .c
}

/*
Optimization Notes:
	1) Use:	window_bufnum = outputBufNum;
	  in place of to_buffer_num( outputBufNum ); !!!!!big difference

	2) Use primitive functions wherever possible.

	In the following example the parse_string primitive is much much faster
	than its seemingly simple replacement.
	
	parse_string( 1, "...", d)
	iparse( 1, d );	

	iparse23( three, s )
	char *s;
	{
		s[0] = curchar();
		point++;
		s[1] = curchar();
		point++;
		if( three ){
			s[2] = curchar();
			s[3] ='\0';
		}
		else
			s[2] = '\0';

	}

*/
